// DesktopArray.h
// declaration file for the class DesktopArray

#ifndef DESKTOP_ARRAY_H_INCLUDED
#define DESKTOP_ARRAY_H_INCLUDED

#include <winnetwk.h>
#include <shlobj.h>
#include <afxtempl.h>

class CMenu;

class desktop_entry {
public:
	desktop_entry() : m_pmalloc(NULL),m_pcontextmenu(NULL),m_pidl(NULL) { }
	~desktop_entry();
	void Shrink();	// releases any OLE, string memory
	CString m_string;
	ULONG m_attribs;
	LPMALLOC m_pmalloc;
	LPCONTEXTMENU m_pcontextmenu;
	LPITEMIDLIST m_pidl;
};

class DesktopArray {
private:
	struct invoker {
		LPCONTEXTMENU cxm;
		WORD id;
		BOOL enabled;
	};
	CArray<invoker,invoker&> m_invoker_array;
protected:
	void ProcessMenuIntoInvoker(LPCONTEXTMENU cxm,CMenu* cmp,LPMENUITEMINFO lpmii);
public:
	enum { kMaxEntries = 250 };
	DesktopArray();
	~DesktopArray();
	void Shrink(); // calls Shrink() on all m_arr members
	void FillFromDesktop();
	int HasItems() { return m_nbr_items; }
	void AddAllItemsToMenu(CMenu* menu);
	int ExecuteCommandID(UINT id);
	BOOL IsCommandIDEnabled(UINT id);
	void SetHwnd(HWND hwnd) { m_hwnd = hwnd; }
private:
	HWND m_hwnd;
	LPMALLOC m_pmalloc;
	int m_nbr_items;
	int m_must_reload;
	desktop_entry m_arr[kMaxEntries];
};

#endif // DESKTOP_ARRAY_H_INCLUDED
